Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# gnBaseSpec Class Reference

gnBaseSpec is the class which stores genetic information and is best accessed using gnSequence. More...

`#include <gnBaseSpec.h>`

Inheritance diagram for gnBaseSpec::

List of all members.

## Public Methods
| gnBaseSpec ()
virtual | ~gnBaseSpec ()
| Destructor, frees memory. More...
virtual gnBaseSpec* | Clone () const=0
virtual gnBaseSpec* | CloneRange (const uint32 startI, const uint32 len) const=0
virtual string | GetName () const
| Get the name of the contig associated with this spec. More...
virtual void | SetName (const string &name)
| Sets the name for this contig. More...
virtual gnSeqI | GetLength () const=0
| Get the length of all the sequence data covered by this spec. More...
virtual boolean | IsReverseComplement () const
| Returns true if this spec is read reverse complement. More...
virtual boolean | IsCircular () const
| Returns true if this spec's sequence is circular. More...
virtual void | SetReverseComplement (const boolean value)=0
| Sets the reverse complement bit for this spec. More...
virtual void | SetCircular (const boolean value)
| Sets whether this spec should be read circular. More...
virtual void | CropStart (gnSeqI cropLen)=0
| Crop the first cropLen bases from the sequence. More...
virtual void | CropEnd (gnSeqI cropLen)=0
| Crop the last cropLen bases from the sequence. More...
virtual boolean | SeqRead (const gnSeqI start, gnSeqC *buf, uint32 &bufLen, const uint32 contigI) const=0
| Reads sequence data from this spec. More...
virtual void | Clear ()
| Clears all data from this spec. More...
## Protected Attributes
boolean | m_reverseComplement
boolean | m_circular
string | m_name
string | m_sourceName

## Detailed Description

gnBaseSpec is the class which stores genetic information and is best accessed using gnSequence.

Definition at line 28 of file gnBaseSpec.h.

## Constructor & Destructor Documentation

gnBaseSpec::gnBaseSpec ( | )`[inline]`

| Definition at line 31 of file gnBaseSpec.h.

gnBaseSpec::~gnBaseSpec ( | )`[inline, virtual]`

| Destructor, frees memory. Definition at line 35 of file gnBaseSpec.h.

## Member Function Documentation

void gnBaseSpec::Clear ( | )`[inline, virtual]`

| Clears all data from this spec. Reimplemented in gnContigSpec, gnFragmentSpec, gnGenomeSpec, gnMultiSpec, gnSourceSpec, and gnStringSpec. Definition at line 137 of file gnBaseSpec.h. Referenced by gnMultiSpec::Clear(), and gnContigSpec::Clear().

gnBaseSpec * gnBaseSpec::Clone ( | ) const`[pure virtual]`

| Reimplemented from gnClone. Reimplemented in gnContigSpec, gnFragmentSpec, gnGenomeSpec, gnMultiSpec, gnSourceSpec, and gnStringSpec.

gnBaseSpec * gnBaseSpec::CloneRange ( | const uint32 startI,
| const uint32 len ) const`[pure virtual]`

| Reimplemented in gnContigSpec.

void gnBaseSpec::CropEnd ( | gnSeqI cropLen )`[pure virtual]`

  | Crop the last cropLen bases from the sequence. CropEnd will delete features and headers associated with the cropped bases. Parameters:
  cropLen | The number of base pairs to delete from the end.
Reimplemented in gnContigSpec, gnFragmentSpec, and gnMultiSpec. Referenced by gnMultiSpec::CropEnd().

void gnBaseSpec::CropStart ( | gnSeqI cropLen )`[pure virtual]`

  | Crop the first cropLen bases from the sequence. CropStart will delete features and headers associated with the cropped bases. Parameters:
  cropLen | The number of base pairs to delete from the beginning.
Reimplemented in gnContigSpec, gnFragmentSpec, and gnMultiSpec. Referenced by gnMultiSpec::CropStart().

gnSeqI gnBaseSpec::GetLength ( | ) const`[pure virtual]`

| Get the length of all the sequence data covered by this spec. Returns: This spec's length in base pairs. Reimplemented in gnContigSpec, and gnMultiSpec. Referenced by gnMultiSpec::CropEnd(), gnMultiSpec::CropStart(), gnDNXSource::GetContigSeqLength(), gnMultiSpec::GetLength(), gnMultiSpec::GetSpecEndBase(), gnMultiSpec::GetSpecIndexByBase(), gnMultiSpec::GetSpecStartBase(), and gnMultiSpec::SeqRead().

string gnBaseSpec::GetName ( | ) const`[inline, virtual]`

| Get the name of the contig associated with this spec. Returns: The contig name or an empty string if none exists. Definition at line 117 of file gnBaseSpec.h. Referenced by gnDNXSource::GetContigID(), gnDNXSource::GetContigName(), gnMultiSpec::GetSpecIndexByName(), gnDNXSource::HasContig(), gnGBKSource::Write(), gnDNXSource::Write(), and gnSequence::contigName().

boolean gnBaseSpec::IsCircular ( | ) const`[inline, virtual]`

| Returns true if this spec's sequence is circular. Returns: True if this spec's sequence is circular. Definition at line 129 of file gnBaseSpec.h. Referenced by gnGBKSource::Write(), and gnSequence::isCircular().

boolean gnBaseSpec::IsReverseComplement ( | ) const`[inline, virtual]`

| Returns true if this spec is read reverse complement. Returns: True if this spec is read reverse complement. Definition at line 125 of file gnBaseSpec.h. Referenced by gnGenomeSpec::SetReverseComplement(), gnFragmentSpec::SetReverseComplement(), gnSequence::globalToSource(), and gnSequence::isReverseComplement().

boolean gnBaseSpec::SeqRead ( | const gnSeqI start,
| gnSeqC * buf,
| uint32 & bufLen,
| const uint32 contigI ) const`[pure virtual]`

  | Reads sequence data from this spec. SeqRead will attempt to read "bufLen" base pairs starting at "start", an offset into the sequence. Reading inside a specific contig can be accomplished by supplying the "contigI" parameter with a valid contig index. SeqRead stores the sequence data in "buf" and returns the actual number of bases read in "bufLen". SeqRead will return false if a serious error occurs. Parameters:
  start | The base pair to start reading at.
  buf | The character array to store base pairs into.
  bufLen | The number of base pairs to read. This will be modified to reflect the actual number of bases read.
  contigI | The index of the subspec to read or ALL_CONTIGS by default.
Returns: True if the operation was successful. Reimplemented in gnContigSpec, and gnMultiSpec. Referenced by gnMultiSpec::SeqRead().

void gnBaseSpec::SetCircular ( | const boolean value )`[inline, virtual]`

  | Sets whether this spec should be read circular. If circular is set, reads beyond the end of this spec will pick up at the beginning and read up to the start index. Parameters:
  value | True for circular, false otherwise.
Definition at line 133 of file gnBaseSpec.h. Referenced by gnSEQSource::ParseStream(), gnGBKSource::ParseStream(), and gnSequence::setCircular().

void gnBaseSpec::SetName ( | const string & name )`[inline, virtual]`

  | Sets the name for this contig. Parameters:
  contigName | The new name.
Returns: True if successful. Honestly, I don't know how this could be unsuccessful... Definition at line 121 of file gnBaseSpec.h. Referenced by gnFASSource::GetSpec(), gnSEQSource::ParseStream(), gnGBKSource::ParseStream(), gnDNXSource::ParseStream(), and gnSequence::setContigName().

void gnBaseSpec::SetReverseComplement ( | const boolean value )`[pure virtual]`

  | Sets the reverse complement bit for this spec. Parameters:
  value | True for reverse complement, false otherwise.
Reimplemented in gnContigSpec, gnFragmentSpec, and gnGenomeSpec. Referenced by main().

## Member Data Documentation

boolean gnBaseSpec::m_circular`[protected]`

| Definition at line 109 of file gnBaseSpec.h.

string gnBaseSpec::m_name`[protected]`

| Definition at line 111 of file gnBaseSpec.h.

boolean gnBaseSpec::m_reverseComplement`[protected]`

| Definition at line 108 of file gnBaseSpec.h.

string gnBaseSpec::m_sourceName`[protected]`

| Reimplemented in gnMultiSpec. Definition at line 112 of file gnBaseSpec.h.

The documentation for this class was generated from the following file:

- gnBaseSpec.h